using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized; 
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System.Collections.Generic;

namespace ComboBox
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridGroupingControl1
            // 
            this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupingControl1.Location = new System.Drawing.Point(12, 12);
            this.gridGroupingControl1.Name = "gridGroupingControl1";
            this.gridGroupingControl1.Size = new System.Drawing.Size(504, 350);
            this.gridGroupingControl1.TabIndex = 0;
            this.gridGroupingControl1.Text = "gridGroupingControl1";
            this.gridGroupingControl1.VersionInfo = "4.402.0.51";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(528, 374);
            this.Controls.Add(this.gridGroupingControl1);
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{

            MyTable a = new MyTable();
            for (int i = 0; i < 10; i++)
            {
                MyRow test = new MyRow();
                a.Add(test);
            }
            gridGroupingControl1.DataSource = a;

            GridEngine engine = gridGroupingControl1.Engine;
            GridTableDescriptor parentTD = (GridTableDescriptor)engine.TableDescriptor;

            gridGroupingControl1.Appearance.AnyCell.ShowButtons = GridShowButtons.ShowCurrentRow;

            gridGroupingControl1.TableModel.CellModels.Add("MyComboBox", new MyComboBoxCellModel(gridGroupingControl1.TableModel));

            GridTableCellStyleInfo valueStyle = parentTD.Columns["Data"].Appearance.AnyRecordFieldCell;
            valueStyle.CellType = "MyComboBox";
            //valueStyle.CellValueType = typeof(string);
            valueStyle.CellValueType = typeof(MyObject);
		}
	}

	public class MyComboBoxCellModel : GridComboBoxCellModel
	{
		public MyComboBoxCellModel(GridModel grid)
			: base(grid)
		{
		 
		}

		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{
			return new MyComboBoxCellRenderer(control, this);
		}
	}

	public class MyComboBoxCellRenderer : GridComboBoxCellRenderer
	{
		public MyComboBoxCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
			: base(grid, cellModel)
		{
			this.SupportsFocusControl = false;
            RemoveButton(DropDownButton);
            this.SupportsFocusControl = true;
            this.StyleInfo.DropDownStyle = GridDropDownStyle.Editable;
		}

        protected override bool OnValidate()
        {
            MyObject obj = this.CurrentStyle.CellValue as MyObject;
            if (obj == null)
            {
                MessageBox.Show("Why is CellValue a null reference?");
                return false;
            }
            else
                return obj.Validate(TextBox.Text);
        }



        protected override bool OnSaveChanges()
        {
            MyObject obj = this.CurrentStyle.CellValue as MyObject;
            if (obj != null)
            {
                obj.Value = Double.Parse(ControlText);
                ControlValue = obj;
                return base.OnSaveChanges();
            }
            return base.OnSaveChanges();
        }
	}

    public class MyTable : BindingList<MyRow>, ITypedList
    {
        #region ITypedList Members

        public PropertyDescriptorCollection GetItemProperties(PropertyDescriptor[] listAccessors)
        {
            List<PropertyDescriptor> newList = new List<PropertyDescriptor>();
            PropertyDescriptorCollection coll = TypeDescriptor.GetProperties(typeof(MyRow));
            foreach (PropertyDescriptor prop in coll)
            {
                if (prop.IsBrowsable)
                    newList.Add(prop);
            }
            return new PropertyDescriptorCollection(newList.ToArray());
        }

        public string GetListName(PropertyDescriptor[] listAccessors)
        {
            return "MyTable";
        }

        #endregion
    }

    public class MyRow
    {
        private MyObject m_Data;

        public MyRow()
        {
            m_Data = new MyObject();
        }

        public MyObject Data
        {
            get
            {
                return m_Data;
            }
            set
            {
                m_Data = value;
            }
        }
    }

    public class MyObject
    {
        private double m_Value;

        public MyObject()
        {
            m_Value = 10;
        }

        public MyObject(string value)
        {
            if (Validate(value))
            {
                m_Value = Double.Parse(value);
            }
            else
                m_Value = 0;
        }

        [Browsable(false)]
        public double Value
        {
            get
            {
                return m_Value;
            }
            set
            {
                m_Value = value;
            }
        }

        public bool Validate(string value)
        {
            double result;
            if (Double.TryParse(value, out result))
            {
                if (result > 5 & result < 100)
                    return true;
                else
                    return false;
            }
            else
                return false;

        }

        public override string ToString()
        {
            return Value.ToString();
        }
    }
}
